package com.marvinelsen.willow.ui

import com.marvinelsen.willow.domain.Sentence
import javafx.beans.property.SimpleStringProperty
import javafx.beans.property.StringProperty

data class SentenceFx(
    val traditionalProperty: StringProperty,
    val simplifiedProperty: StringProperty,
)

fun Sentence.toFx() = SentenceFx(
    traditionalProperty = SimpleStringProperty(this.traditional),
    simplifiedProperty = SimpleStringProperty(this.simplified),
)

fun SentenceFx.toDomain() = Sentence(
    traditional = this.traditionalProperty.value,
    simplified = this.simplifiedProperty.value,
)
